// Copyright (c) 1999, A.H. van den Boogaard

#ifndef FTUTILS_H
#define FTUTILS_H

#include <sys/timeb.h>
#include <iostream>
#include <string>

class StopWatch
{
   private:
      timeb start_time;
      long  total_seconds, lap_seconds;
      int   total_msecs, lap_msecs;
      bool  active;

      void update();

   public:
      StopWatch( bool directstart=false );
      ~StopWatch(){}

      void start();
      void stop();
      void reset();
      double elapsed();
      double lap();
      bool running(){ return active; }
};

class SelfTimer:public StopWatch
{
   private:
      std::string text;

   public:
      SelfTimer( std::string t="" ):StopWatch(), text(t){ start(); }
      ~SelfTimer(){ std::cout << std::endl << text << ' ' << elapsed() << "s"
	                      << std::endl; }
};

#ifdef FT_GUI
void show_criterion( float crit );                   // defined in winfem2.cpp
void show_convergence( float unb, bool highlight );  // defined in winfem2.cpp
#endif

#endif // FTUTILS_H
