// Copyright (c) 1999, A.H. van den Boogaard

#ifndef GRAPHICS_H
#define GRAPHICS_H

class DrawProperties
{
   friend class DrawPropDialog;

   private:
      bool    elmnr, nodenr, displaced, undeformed;
      double  magnify, slowdown;
      int     frequency;

   public:
      wxFont   elementFont;
      wxColour elementFontColor;
      wxFont   nodeFont;
      wxColour nodeFontColor;
      wxFont   graphicsFont;
      wxColour graphicsFontColor;

      DrawProperties();
      ~DrawProperties(){}

      void init();

      bool plot_node_nrs() const { return nodenr; }
      bool plot_element_nrs() const { return elmnr; }
      bool plot_displaced() const { return displaced; }
      bool plot_undeformed() const { return undeformed; }
      float displa_scale() const { return magnify; }
      float slow_down() const { return slowdown; }
      int plot_steps() const { return frequency; }
};

#endif /* GRAHPICS_H */
