// Copyright (c) 1999, A.H. van den Boogaard

#ifndef SCREENMAP_H
#define SCREENMAP_H

#include <wx/gdicmn.h>

class DeviceMap
{
   private:
      float x0, y0, scale;

   public:
      DeviceMap( float x=0, float y=0, float s=1 ):x0(x),y0(y),scale(s){}
      ~DeviceMap(){}

      void    setOrigin( float x, float y );
      void    setScale( float s );

      wxCoord toScreen( float size ) const;
      wxCoord XtoScreen( float x ) const;
      wxCoord YtoScreen( float y ) const;
      wxPoint toScreen( float x, float y ) const;
      float   toX( float x ) const;
      float   toY( float y ) const;
      wxPoint toPhys( wxPoint ) const;
      void    toPhys( float &x, float &y ) const;

      void    shiftLeft( float deltaX );
      void    shiftUp( float deltaY );
      void    zoom( float factor );
};

#endif /* SCREENMAP_H */
