// Copyright (c) 2005, A.H. van den Boogaard

/*
   set of functions to calculate eigenvalues and optionally eigenvectors
   of a matrix
*/

#ifndef EIGEN_H
#define EIGEN_H

#include "ftmatrix.h"

namespace FeaTure
{

void householder( Matrix *A, Matrix *V=0 );
bool symmetric( const Matrix &A );
void symmetricQR( Matrix *Tp, Matrix *V=0 );
int SturmSequence( const Matrix &A, double shift=0 );
void GenEigen( Matrix *Ap, Matrix *Bp,
               Vector *lambda, Matrix *Vp=0 );
void InverseIteration( const Matrix &A, Vector *xp, double *lambda );

} // namespace FeaTure

#endif // EIGEN_H
