// Copyright (c) 2005, A.H. van den Boogaard

/*
   set of functions to calculate triangular decompositions of a full matrix
   and several functions of triangular matrices
*/

#ifndef TRIANGULAR_H
#define TRIANGULAR_H

#include "ftmatrix.h"

namespace FeaTure
{

// Decompositions and vector substitutions

// symmetric matrices
void LDLtDecomposition( Matrix *Ap );
void LDLtSubstitution( const Matrix &LDLt, Vector *xp );
void CholeskyDecomposition( Matrix *Ap );
void CholeskySubstitution( const Matrix &LLt, Vector *xp );


// Triangular (inverse) matrix - matrix multiplications

void PostMultLowerTInv( Matrix *Ap, const Matrix &L );
void PreMultLowerInv( const Matrix &L, Matrix *Ap );
void PreMultLowerTInv( const Matrix &L, Matrix *Ap );

Matrix PreMultLower( const Matrix &L, const Matrix &A );
Matrix PostMultLowerT( const Matrix &A, const Matrix &L );
Matrix PreMultLowerT( const Matrix &L, const Matrix &A );

} // namespace FeaTure

#endif // TRIANGULAR_H
