// Copyright (c) 1999, A.H. van den Boogaard

#include "collect.h"

using FeaTure::Vector;
using FeaTure::Matrix;
using FeaTure::CollectArray;

void CollectArray::add( const Vector& v )
{
    size_t N = v.size();
    size_t i;
    for (i=0; i<N; i++) add( v[i] );
}

void CollectArray::add( const Matrix& m )
{
    size_t M = m.size1();
    size_t N = m.size2();
    size_t i,j;

    for (i=0; i<M; i++)
        for (j=0; j<N; j++)
            add( m[i][j] );
}
      
void CollectArray::extract( Vector& v ) const
{
    size_t N = v.size();
    size_t i;
    for (i=0; i<N; i++) v[i] = extract();
}

void CollectArray::extract( Matrix& m ) const
{
    size_t M = m.size1();
    size_t N = m.size2();
    size_t i,j;

    for (i=0; i<M; i++)
        for (j=0; j<N; j++)
            m[i][j] = extract();
}

std::ostream& FeaTure::operator<<(std::ostream &s, const CollectArray &A)
{
    int N=A.size();

    s <<  N << std::endl;

    for (int i=0; i<N; i++)
        s   << A[i] << " " << std::endl;
    s << std::endl;

    return s;
}

std::istream& FeaTure::operator>>(std::istream &s, CollectArray &A)
{
    int N;

    s >> N;

    A.resize(N);

    for (int i=0; i<N; i++)
            s >>  A[i];

    return s;
}

